--- init/do_mounts.org.c	2009-11-30 19:24:05.000000000 +0100
+++ init/do_mounts.c	2009-11-30 19:29:53.000000000 +0100
@@ -185,6 +185,17 @@
 __setup("rootfstype=", fs_names_setup);
 __setup("rootdelay=", root_delay_setup);
 
+/* Added by milyges <milyges@gmail.com> */
+static char * __initdata system_root;
+static int __init system_root_setup(char * str)
+{
+	system_root = str;
+	return 1;
+}
+
+__setup("chroot=", system_root_setup);
+/* </added>*/
+
 static void __init get_fs_names(char *page)
 {
 	char *s = page;
@@ -361,7 +372,7 @@
  */
 void __init prepare_namespace(void)
 {
-	int is_floppy;
+	int is_floppy, err;
 
 	if (root_delay) {
 		printk(KERN_INFO "Waiting %dsec before mounting root device...\n",
@@ -408,5 +419,15 @@
 out:
 	sys_mount(".", "/", NULL, MS_MOVE, NULL);
 	sys_chroot(".");
+	
+	/* Added by milyges <milyges@gmail.com> */
+	if (system_root)
+	{
+		printk("Chrooting into %s\n", system_root);
+		err = sys_chroot(system_root);
+		if (err != 0)
+			panic("Unable to chroot into %s\n", system_root);
+	}
+	/* </added>*/
 }
 
